package betterwithmods.client.container.bulk;

import betterwithmods.common.blocks.mechanical.tile.TileEntityCookingPot;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.ClickType;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.IContainerListener;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraftforge.items.CapabilityItemHandler;
import net.minecraftforge.items.IItemHandler;
import net.minecraftforge.items.SlotItemHandler;

public class ContainerCookingPot extends Container {
    private final TileEntityCookingPot tile;
    private int lastCookCounter;

    public ContainerCookingPot(EntityPlayer player, TileEntityCookingPot tile) {
        IItemHandler playerInv = player.getCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null);
        this.tile = tile;
        this.lastCookCounter = 0;

        for (int i = 0; i < 3; i++) {
            for (int j = 0; j < 9; j++) {
                func_75146_a(new SlotItemHandler(tile.inventory, j + i * 9, 8 + j * 18, 43 + i * 18));
            }
        }

        for (int i = 0; i < 3; i++) {
            for (int j = 0; j < 9; j++) {
                func_75146_a(new SlotItemHandler(playerInv, j + i * 9 + 9, 8 + j * 18, 111 + i * 18));
            }
        }

        for (int i = 0; i < 9; i++) {
            func_75146_a(new SlotItemHandler(playerInv, i, 8 + i * 18, 169));
        }
    }

    @Override
    public boolean func_75145_c(EntityPlayer player) {
        return this.tile.isUseableByPlayer(player);
    }

    @Override
    public ItemStack func_184996_a(int x, int dragType, ClickType type, EntityPlayer player) {
        this.tile.func_70296_d();
        return super.func_184996_a(x, dragType, type, player);
    }

    @Override
    public ItemStack func_82846_b(EntityPlayer player, int slotIndex) {
        ItemStack stack = ItemStack.field_190927_a;
        Slot slot = this.field_75151_b.get(slotIndex);

        if (slot != null && slot.func_75216_d()) {
            ItemStack stack1 = slot.func_75211_c();
            stack = stack1.func_77946_l();

            if (slotIndex < 27) {
                if (!func_75135_a(stack1, 27, this.field_75151_b.size(), true))
                    return ItemStack.field_190927_a;
            } else if (!func_75135_a(stack1, 0, 27, false))
                return ItemStack.field_190927_a;

            if (stack1.func_190916_E() < 1)
                slot.func_75215_d(ItemStack.field_190927_a);
            else
                slot.func_75218_e();
        }
        return stack;
    }

    @Override
    public void func_75132_a(IContainerListener listener) {
        super.func_75132_a(listener);
        listener.func_71112_a(this, 0, this.tile.scaledCookCounter);
    }

    @Override
    public void func_75142_b() {
        super.func_75142_b();

        for (IContainerListener craft : this.field_75149_d) {
            if (this.lastCookCounter != this.tile.scaledCookCounter)
                craft.func_71112_a(this, 0, this.tile.scaledCookCounter);
        }
        this.lastCookCounter = this.tile.scaledCookCounter;
    }

    @Override
    public void func_75137_b(int index, int value) {
        if (index == 0)
            this.tile.scaledCookCounter = value;
    }

}
