package betterwithmods.common.blocks;

import betterwithmods.common.BWMBlocks;
import betterwithmods.util.WorldUtils;
import net.minecraft.block.BlockDirt;
import net.minecraft.block.BlockGrass;
import net.minecraft.block.SoundType;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import java.util.Random;

/**
 * Custom grass block. Spreading now handles {@link BlockDirtSlab}, and only works in sunlight.
 * @author Koward
 */
public class BlockGrassCustom extends BlockGrass {
    public BlockGrassCustom() {
        super();
        this.func_149711_c(0.6F);
        this.func_149672_a(SoundType.field_185850_c);
    }


    /**
     * Spread grass or turn grass back to dirt.
     * Based on {@link BlockGrass#updateTick(World, BlockPos, IBlockState, Random)} build 2185
     */
    public static void handleGrassSpreading(World worldIn, BlockPos pos, Random rand, IBlockState dirtState) {
        if (!worldIn.field_72995_K) {
            int shrinkLight = WorldUtils.getNaturalLightFromNeighbors(worldIn, pos.func_177984_a());
            int growthLight = shrinkLight - worldIn.func_175657_ab();
            if (shrinkLight < 9 && worldIn.func_180495_p(pos.func_177984_a()).getLightOpacity(worldIn, pos.func_177984_a()) > 2) {
                worldIn.func_175656_a(pos, dirtState);
            } else {
                if (growthLight >= 11) {
                    BlockPos blockpos = pos.func_177982_a(rand.nextInt(3) - 1, rand.nextInt(5) - 3, rand.nextInt(3) - 1);

                    if (blockpos.func_177956_o() >= 0 && blockpos.func_177956_o() < 256 && !worldIn.func_175667_e(blockpos)) {
                        return;
                    }

                    IBlockState iblockstate = worldIn.func_180495_p(blockpos.func_177984_a());
                    IBlockState iblockstate1 = worldIn.func_180495_p(blockpos);

                    if (iblockstate1.func_177230_c() == Blocks.field_150346_d && iblockstate1.func_177229_b(BlockDirt.field_176386_a) == BlockDirt.DirtType.DIRT && WorldUtils.getNaturalLightFromNeighbors(worldIn, blockpos.func_177984_a()) >= 11 && iblockstate.getLightOpacity(worldIn, pos.func_177984_a()) <= 2) {
                        worldIn.func_175656_a(blockpos, Blocks.field_150349_c.func_176223_P());
                    } else if (iblockstate1.func_177230_c() == BWMBlocks.DIRT_SLAB && iblockstate1.func_177229_b(BlockDirtSlab.VARIANT) == BlockDirtSlab.DirtSlabType.DIRT && WorldUtils.getNaturalLightFromNeighbors(worldIn, blockpos.func_177984_a()) >= 11 && iblockstate.getLightOpacity(worldIn, pos.func_177984_a()) <= 2) {
                        worldIn.func_175656_a(blockpos, BWMBlocks.DIRT_SLAB.func_176223_P().func_177226_a(BlockDirtSlab.VARIANT, BlockDirtSlab.DirtSlabType.GRASS));
                    } else if (iblockstate1.func_177230_c() == Blocks.field_150458_ak && rand.nextInt(3) == 0 && worldIn.func_175623_d(blockpos.func_177984_a())) {
                        int light = WorldUtils.getNaturalLightFromNeighbors(worldIn, blockpos.func_177984_a());
                        if (light >= 11) {
                            worldIn.func_175656_a(blockpos.func_177984_a(), Blocks.field_150329_H.func_176223_P());
                        }
                    }
                }
            }
        }
    }

    @Override
    public void func_180650_b(World worldIn, BlockPos pos, IBlockState state, Random rand) {
        handleGrassSpreading(worldIn, pos, rand, Blocks.field_150346_d.func_176223_P());
    }
}
